#!/usr/local/bin/php -q
<?php
// set your Jabber server hostname, username, and password here..  Constants
define("JABBER_SERVER","asterisk.itp.tsoa.nyu.edu");
define("JABBER_USERNAME","webuser");
define("JABBER_PASSWORD","webuser");

define("RUN_TIME",30);  // set a maximum run time of 30 seconds
define("CBK_FREQ",1);   // fire a callback event every second


	// called when a connection to the Jabber server is established
	function handleConnected() {
		GLOBAL $jab;

		echo "Connected!\n";
		
		// now that we're connected, tell the Jabber class to login
		echo "Authenticating ...\n";
		$jab->login(JABBER_USERNAME,JABBER_PASSWORD);
		//                $this->jid              = "{$this->_username}@{$this->_server_host}/{$this->_resource}";

	}
	
	// called after a login to indicate the the login was successful
	function handleAuthenticated() {
		GLOBAL $jab;
		echo "Authenticated!\n";

		$jab->set_presence("","Ya, I'm online... so what?");
		//        function send_presence($type = NULL, $to = NULL, $show = NULL, $status = NULL, $priority = NULL) {
		$jab->send_presence("","test@test.asterisk.itp.tsoa.nyu.edu/awebuser");

		//$jab->message("test@test.asterisk.itp.tsoa.nyu.edu","groupchat",NULL,"Hi");
	}
	
	// called after a login to indicate that the login was NOT successful
	function handleAuthFailure($code,$error) {
		GLOBAL $jab;
		echo "Authentication failure: $error ($code)\n";
		
		// set terminated to TRUE in the Jabber class to tell it to exit
		$jab->terminated = true;
	}
	
	// called periodically by the Jabber class to allow us to do our own
	// processing
	function handleHeartbeat() {
		GLOBAL $jab;
		echo "Waiting for incoming message ...\n";
	}
	
	// called when an error is received from the Jabber server
	function handleError($code,$error,$xmlns) {
		GLOBAL $jab;
		echo "Error: $error ($code)".($xmlns?" in $xmlns":"")."\n";
	}
	
	// called when a message is received from a remote contact
	function handleMessage($from,$to="",$body="",$subject="",$thread="",$id="",$extended="") {
		GLOBAL $jab;


		echo "Incoming message!\n";

		if (is_array($from))
		{
			print_r($from);
		}

		echo "From: $from\t\tTo: $to\n";
		echo "Subject: $subject\tThread; $thread\n";
		echo "Body: $body\n";
		echo "ID: $id\n";
		//var_dump($extended);
		echo "\n";
		echo "Send message\n";
//        function message($to, $type = "normal", $id = NULL, $body = NULL, $thread = NULL, $subject = NULL, $payload = NULL, $raw = false) {

		
		//$jab->message("test@test.asterisk.itp.tsoa.nyu.edu","groupchat",NULL,"Hi");
		//$jab->message($from,"chat",NULL,"Hello! You said: ".$body);
	}
	
	function _contact_info($contact) {
		GLOBAL $jab;
		return sprintf("Contact %s (JID %s) has status %s and message %s\n",$contact['name'],$contact['jid'],$contact['show'],$contact['status']);
	}
	
	function handleRosterUpdate($jid) {
		GLOBAL $jab;
			// the first roster update indicates that the entire roster has been
			// downloaded for the first time
			echo "Roster downloaded:\n";
			
			foreach ($jab->roster as $k=>$contact) {
				echo _contact_info($contact);
			}	
	}
	
	function handleDebug($msg,$level) {
		GLOBAL $jab;
		echo "DBG: $msg\n";
	}

// include the Jabber class
require_once("class_Jabber.php");

// create an instance of the Jabber class
$display_debug_info = true;
$jab = new Jabber($display_debug_info);

// set handlers for the events we wish to be notified about
//        function set_handler_function($handler_name,$method_name) {

$jab->set_handler_function("connected","handleConnected");
$jab->set_handler_function("authenticated","handleAuthenticated");
$jab->set_handler_function("authfailure","handleAuthFailure");
$jab->set_handler_function("heartbeat","handleHeartbeat");
$jab->set_handler_function("error","handleError");

$jab->set_handler_function("message_normal","handleMessage");
$jab->set_handler_function("message_chat","handleMessage");
$jab->set_handler_function("message_groupchat","handleMessage");
$jab->set_handler_function("message_headline","handleMessage");

$jab->set_handler_function("debug_log","handleDebug");
$jab->set_handler_function("rosterupdate","handleRosterUpdate");

echo "Connecting ...\n";

// connect to the Jabber server
if (!$jab->connect(JABBER_SERVER)) {
	die("Could not connect to the Jabber server!\n");
}

// now, tell the Jabber class to begin its execution loop
$jab->execute(CBK_FREQ,RUN_TIME);

// Note that we will not reach this point (and the execute() method will not
// return) until $jab->terminated is set to TRUE.  The execute() method simply
// loops, processing data from (and to) the Jabber server, and firing events
//
// This event-based model will be familiar to programmers who have worked on
// desktop applications, particularly in Win32 environments.

// disconnect from the Jabber server
//$jab->terminated = true;
$jab->disconnect();
?>
